/**************  Test Main Program Individual Voice *********************/

//#define _debug_

#include <iostream.h>

#include "miditabl.h"
#include "RTWvOut.h"
#include "SndWvOut.h"
#include "SKINI08.h"
#include "Instrmnt.h"
#include "Marimba.h"
#include "Vibraphn.h"
#include "AgogoBel.h"
#include "Plucked.h"
#include "Mandolin.h"
#include "Clarinet.h"
#include "Flute.h"
#include "Brass.h"
#include "Bowed.h"
#include "Rhodey.h"
#include "Wurley.h"
#include "TubeBell.h"
#include "HeavyMtl.h"
#include "PercFlut.h"
#include "BeeThree.h"
#include "FMVoices.h"
#include "VoicForm.h"
#include "Moog1.h"
#include "Reverb.h"

int main(int argc,char *argv[])
{
    long i, j;
    MY_FLOAT temp,temp2;
    Instrmnt *instrument;    
    WvOut *output;
    Reverb reverb(2137);
    SKINI08 *score;
	
    output = new RTWvOut("test.snd");

    instrument = new PercFlut;


    score = new SKINI08("scores/spain.ski");

    reverb.setEffectMix(0.2);

#if 1
    while(score->getType() > 0)	{
        j = (long) (score->getDelta() * SRATE);
#if defined(_debug_) 
	printf("%i\n",j);
#endif
	if (j > 0)	{
	    for (i=0;i<j;i++)	{
		output->tick(reverb.tick(instrument->tick()));
	    }
	}
 	temp2 = score->getByteThree()*NORM_7;
	if (score->getType()==9)	{
	    if (score->getByteThree() == 0) 
 		instrument->noteOff(temp2);
	    else {
	        j = (int) score->getByteTwo();
	    	temp = __MIDI_To_Pitch[j];
		instrument->noteOn(temp,temp2);
#ifdef _debug_
		cout << temp << " " << temp2 << endl;
#endif
	    }
	}
        else if (score->getType() == 8)	{
	    instrument->noteOff(temp2);
	}
	else if (score->getType() == 11)	{
	    j = (int) score->getByteTwo();
	    instrument->controlChange(j,temp2*128.0);
	}
	score->nextMessage();
    }
#else


//     output->tick(reverb.tick(instrument->tick()));

    while(1) {
      instrument->noteOn(60.0,.9);
      
      for (i=0;i<22000;i++)	{	/* let the reverb settle a little */
	output->tick(reverb.tick(instrument->tick()));
      }

      int it = (it+1000)%(127*127);
      temp=it;
      instrument->controlChange(4,temp);
      
    }

#endif

    delete score;
    delete instrument;
	delete output;

}

    
